﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;

namespace xamGrid
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
    }

    public class CustomIconConditionalFormatRule : IconConditionalFormatRule
    {
        public DataTemplate Icon { get; set; }

        protected override IConditionalFormattingRuleProxy CreateProxy()
        {
            return new CustomIconConditionalFormatRuleProxy(Icon);
        }
    }

    public class CustomIconConditionalFormatRuleProxy : IconConditionalFormatRuleProxy
    {
        private DataTemplate iconTemplate;

        public CustomIconConditionalFormatRuleProxy(DataTemplate icon)
        {
            iconTemplate = icon;
        }

        protected override Style EvaluateCondition(object sourceDataObject, object sourceDataValue)
        {
            DummyData data = sourceDataObject as DummyData;

            if (data.Numbers > data.Percentage)
            {
                Style s = new Style();
                s.TargetType = typeof(ConditionalFormattingCellControl);
                s.Setters.Add(new Setter(ConditionalFormattingCellControl.IconProperty, this.iconTemplate));
                return s;
            }

            return null;
        }
    }
}
